import pytest as pt
import os
from pathlib import Path
from pybuilder.core import Project

from src.main.python.ddadevops.release_mixin import ReleaseMixin
from src.main.python.ddadevops.domain import Devops, Release
from .domain.helper import devops_config
from .resource_helper import copy_resource


def test_release_mixin(tmp_path):
    str_tmp_path = str(tmp_path)
    copy_resource(Path("package.json"), tmp_path)
    project = Project(str_tmp_path, name="name")

    sut = ReleaseMixin(
        project,
        devops_config(
            {
                "project_root_path": str_tmp_path,
                "mixin_types": ["RELEASE"],
                "build_types": [],
                "module": "release-test",
            }
        ),
    )

    sut.initialize_build_dir()
    assert sut.build_path() == f"{str_tmp_path}/target/name/release-test"
